/****************************************************************************

                                 FONT EDITOR

                          (c) 28-05-97  by S.HELLEU
                          
                          Compiler: Watcom C++
                          
                          http://www.flashtux.org
                          flashcode@flashtux.org

****************************************************************************/

#include <stdio.h>

char	date[9] = "03-06-97";

unsigned char	fonte[3][256][16];	// les 3 fontes (8x8,8x14,8x16)
unsigned char	nfonte[3][256][16];	// les 3 nouvelles fontes cres
unsigned char	select[3][256];		// caractre(s) slectionn(s)
unsigned int	hauteur[3]={8,14,16};	// hauteur de chaque fonte
unsigned char	numfonte;		// numro de la fonte utilise
unsigned int	bout,xs,ys;		// infos souris
unsigned char	numcarac;		// caractre slectionn
unsigned char	carac[16];		// caractre en cours de cration
unsigned char	scan_code;		// scan_code du caractre lu par ReadKey

char		nom_fonte[3][10] = { "8x8 font", "8x14 font", "8x16 font" };

char		dernier_fichier[3][42];
char		nom_defaut[3][13]= { "FONT8X8.COM", "FONT8X14.COM", "FONT8X16.COM" };

#pragma aux halt=\
	"mov	ah,4ch	"\
	"int	21h	"\
parm [al] modify [ah];

#pragma aux mode=\
	"xor	ah,ah	"\
	"int	10h  	"\
parm [al] modify [ah];

// =========================== AIDE SOUS DOS ================================

void affiche_aide_DOS()
{
	unsigned int	i;
	unsigned int	nom[19] = { 5194,6413,1696,4399,6890,5194,5141,6095,
					6148,5565,5353,5830,1696,3816,3657,
					4028,4028,3657,4505 };

	printf ("\nFNTED  (c) %s  ",date);

	for (i = 0; i < 19 ; i++)
		printf ("%c", nom[i] / 53);

	printf ("\n\nSyntax: FNTED [/?] | [0|1]\n\n");
	printf ("    /?    this help\n");
	printf ("    0|1   start with font #0 or #1 (0=8x8 1=8x14)\n");
	printf ("          default: start with font #2 (8x16)\n");

	halt (0);
}

// ============================= GRAPHISME ==================================

extern	unsigned char	is_vga ();
#pragma aux is_vga=\
	"	mov	ax,1a00h"\
	"	int	10h	"\
	"	cmp	al,1ah	"\
	"	je	ok	"\
	"	xor	al,al	"\
	"	jmp	fin	"\
	"ok:	mov	al,1	"\
	"fin:			"\
modify [ah] value [al]


#pragma aux waitretrace =\
	"	mov	dx,3dah	"\
	"wait1:			"\
	"	in	al,dx	"\
	"	test	al,08h	"\
	"	jnz	wait1	"\
	"wait2:			"\
	"	in	al,dx	"\
	"	test	al,08h	"\
	"	jz	wait2	"\
modify [al dx];


#pragma aux init_640_480=\
	"mov	ax,0012h"\
	"int	10h	"\
modify [ax];


#pragma aux setpix=\
	"mov	dx,80		"\
	"mul	dx		"\
	"mov	cl,bl		"\
	"shr	bx,1		"\
	"shr	bx,1		"\
	"shr	bx,1		"\
	"add	bx,ax		"\
	"and	cl,7		"\
	"xor	cl,7		"\
	"mov	ah,1		"\
	"shl	ah,cl		"\
	"mov	dx,3ceh		"\
	"mov	al,8		"\
	"out	dx,ax		"\
	"mov	ax,0205h	"\
	"out	dx,ax		"\
	"mov	ax,0A000h	"\
	"mov	es,ax		"\
	"mov	al,es:[bx]	"\
	"mov	al,ch		"\
	"mov	es:[bx],ch	"\
	"mov	ax,0FF08h	"\
	"out	dx,ax		"\
	"mov	ax,0005h	"\
	"out	dx,ax		"\
parm [bx][ax][ch]\
modify [cl dx];


void lineh0 (unsigned int x1,unsigned int x2,unsigned int y,unsigned char coul)
{
	unsigned int	i;

	for (i = x1 ; i <= x2 ; i++)
		setpix (i, y, coul);
}


void linev0 (unsigned int x, unsigned int y1, unsigned int y2, unsigned char coul)
{
	unsigned int	j;

	for (j = y1 ; j <= y2 ; j++)
		setpix (x, j, coul);
}


void rectangle (unsigned int x1, unsigned int y1, unsigned int x2,
                unsigned int y2, unsigned char coul)
{
	lineh (x1, x2, y1, coul);
	lineh (x1, x2, y2, coul);
	linev (x1, y1, y2, coul);
	linev (x2, y1, y2, coul);
}

void bar (unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2,
          unsigned char coul)
{
	unsigned int	j;

	for (j = y1 ; j <= y2 ; j++)
		lineh (x1, x2, j, coul);
}

extern void lineh (unsigned int x1, unsigned int x2, unsigned int y, unsigned char coul);
extern void linev (unsigned int x, unsigned int y1, unsigned int y2, unsigned char coul);

void bar_trame_f (unsigned int x1, unsigned int y1, unsigned int x2,
                  unsigned int y2, unsigned char coul)
// prserve le fond
{
	unsigned int	i, j, k;

	bar (x1, y1, x2, y2, coul);
	return;

	k = (y1%2 == 0) ? 1 : 0;
	for (i = x1 ; i <= x2 ; i++)
		if (i%2 == 0)
			for ( j = y1+1-k ; j <= y2 ; j += 2)
				setpix (i, j, coul);
		else
			for ( j = y1+k ; j <= y2 ; j += 2)
				setpix (i, j, coul);
}

void bar_trame (unsigned int x1,unsigned int y1,unsigned int x2,
                unsigned int y2,unsigned char coul,unsigned char fond)
// ne prserve PAS le fond
{
	unsigned int	i,j,k;

	bar (x1, y1, x2, y2, coul);
	return;

	k=(y1%2==0)?1:0;
	for ( i = x1 ; i <= x2 ; i++)
		if (i%2==0)
		{
			for ( j = y1+1-k ; j <= y2 ; j += 2)
				setpix (i, j, coul);
			for ( j = y1+k ; j <= y2 ; j += 2)
				setpix (i, j, fond);
		}
		else
		{
			for ( j = y1+k ; j <= y2 ; j += 2)
				setpix (i, j, coul);
			for ( j = y1+1-k ; j <= y2 ; j += 2)
				setpix (i, j, fond);
		}
}

void bar3D (unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2,
            unsigned char coul1, unsigned char coul2, unsigned char coul3)
{
	unsigned int	i,j;

	// exemple: coul1 = blanc ; coul2 = gris ; coul3 = gris fonc

/*  for (i=x1+1;i<=x2-1;i++)
    for (j=y1+1;j<=y2-1;j++)
      setpix(i,j,coul2);
  for (i=x1;i<=x2;i++)
    {
      if (i>x1) setpix(i,y2-1,coul3);
      setpix(i,y2,coul3);
      if (i<x2) setpix(i,y1+1,coul1);
      setpix(i,y1,coul1);
    }
  for (j=y1;j<=y2;j++)
    {
      if (j>y1) setpix(x2-1,j,coul3);
      setpix(x2,j,coul3);
      if (j<y2) setpix(x1+1,j,coul1);
      setpix(x1,j,coul1);
    } */
	lineh (x1, x2-1, y1, coul1);
	lineh (x1, x2-2, y1+1, coul1);
	linev (x1, y1+2, y2, coul1);
	linev (x1+1, y1+2, y2-1, coul1);
	lineh (x1+1, x2, y2, coul3);
	lineh (x1+2, x2, y2-1, coul3);
	linev (x2, y1, y2-2, coul3);
	linev (x2-1, y1+1, y2-2, coul3);
	bar (x1+2, y1+2, x2-2, y2-2, coul2);
}

#pragma aux rgb=\
	"mov	dx,3c8h	"\
	"out	dx,al	"\
	"mov	dx,3c9h	"\
	"mov	al,ah	"\
	"out	dx,al	"\
	"mov	al,bl	"\
	"out	dx,al	"\
	"mov	al,bh	"\
	"out	dx,al	"\
parm [al] [ah] [bl] [bh]\
modify [al dx];

// ================================ FONTES ==================================

#pragma aux getfont=\
	"	push	bp			"\
	"	push	es			"\
	"	push	ds			"\
	"	mov	ax,1130h		"\
	"	mov	bh,3			"\
	"	int	10h			"\
	"	mov	di,offset fonte		"\
	"	mov	ax,es			"\
	"	mov	bx,ds			"\
	"	mov	es,bx			"\
	"	mov	ds,ax			"\
	"	mov	si,bp			"\
	"	mov	dx,256			"\
	"b1:	mov	cx,4			"\
	"	rep	movsw			"\
	"	add	di,8			"\
	"	dec	dx			"\
	"	jnz	b1			"\
	"	pop	ds			"\
	"	push	ds			"\
	"	mov	ax,1130h		"\
	"	mov	bh,2			"\
	"	int	10h			"\
	"	mov	di,offset fonte+4096	"\
	"	mov	ax,es			"\
	"	mov	bx,ds			"\
	"	mov	es,bx			"\
	"	mov	ds,ax			"\
	"	mov	si,bp			"\
	"	mov	dx,256			"\
	"b2:	mov	cx,7			"\
	"	rep	movsw			"\
	"	add	di,2			"\
	"	dec	dx			"\
	"	jnz	b2			"\
	"	pop	ds			"\
	"	push	ds			"\
	"	mov	ax,1130h		"\
	"	mov	bh,6			"\
	"	int	10h			"\
	"	mov	di,offset fonte+8192	"\
	"	mov	ax,es			"\
	"	mov	bx,ds			"\
	"	mov	es,bx			"\
	"	mov	ds,ax			"\
	"	mov	si,bp			"\
	"	mov	cx,2048			"\
	"	rep	movsw			"\
	"	pop	ds			"\
	"	pop	es			"\
	"	pop	bp			"\
modify [ax bx cx si di];

void writexy_f (unsigned char nofonte, unsigned int x, unsigned int y,
                unsigned char coul, char *texte)
// crit une chaine en mode graphique, prserve le fond
{
	unsigned int	i = 0, j, k, dx = 0;

	while (texte[i] != 0)
	{
		for (j = 0 ; j < 8 ; j++)
			for (k = 0 ; k < hauteur[nofonte] ; k++)
				if ( (nfonte[nofonte][texte[i]][k] & (1 << (7 - j))) != 0)
					setpix (x + dx + j, y + k, coul);
		dx += 8;
		i++;
	}
}

void writexy (unsigned char nofonte, unsigned int x, unsigned int y,
              unsigned char coul, unsigned char fond, char *texte)
// crit une chaine en mode graphique, ne prserve PAS le fond
{
	unsigned int	i = 0, j, k, dx = 0;

	while (texte[i] != 0)
	{
		for (j = 0 ; j < 8 ; j++)
			for (k = 0 ; k < hauteur[nofonte] ; k++)
				if ( (nfonte[nofonte][texte[i]][k] & (1 << (7 - j))) != 0)
					setpix (x + dx + j, y + k, coul);
				else
					setpix (x + dx + j, y + k, fond);
		dx += 8;
		i++;
	}
}


void writexyc_f (unsigned char nofonte, unsigned int x, unsigned int y,
                 unsigned char coul, char carac)
// crit un caractre en mode graphique, prserve le fond
{
	unsigned int	i, j;

	for (i = 0 ; i < 8 ; i++)
		for (j = 0 ; j < hauteur[nofonte] ; j++)
			if ( (nfonte[nofonte][carac][j] & (1 << (7 - i))) != 0)
				setpix (x + i, y + j, coul);
}

void writexyc (unsigned char nofonte, unsigned int x, unsigned int y,
               unsigned char coul, unsigned char fond, char carac)
// crit un caractre en mode graphique, ne prserve PAS le fond
// UTILISE LA FONTE PAR DEFAUT
{
	unsigned int	i, j;

	for (i = 0 ; i < 8 ; i++)
		for (j = 0 ; j < hauteur[nofonte] ; j++)
			if ( (fonte[nofonte][carac][j] & (1 << (7 - i))) != 0)
				setpix (x + i, y + j, coul);
			else
				setpix (x + i, y + j, fond);
}

// =============================== SOURIS ===================================

extern unsigned char ismouse();
#pragma aux ismouse=\
	"	xor	ax,ax	"\
	"	int	33h	"\
	"	cmp	ax,0	"\
	"	je	fin	"\
	"	mov	al,1	"\
	"fin:			"\
modify [ah bx] value [al];

#pragma aux showmouse=\
	"mov	ax,1	"\
	"int	33h	"\
modify [ax];

#pragma aux hidemouse=\
	"mov	ax,2	"\
	"int	33h	"\
modify [ax];

#pragma aux infomouse=\
	"mov	ax,3	"\
	"int	33h	"\
	"mov	bout,bx	"\
	"mov	xs,cx	"\
	"mov	ys,dx	"\
modify [ax bx cx dx];

// ==========================================================================

void retour_dos()
{
	unsigned int	i;
	int		nom[19] =
			{ 1122,2057,544,1411,2210,1666,1649,1955,1972,1785,
			1717,1870,544,1224,1173,1292,1292,1173,1445 };

	mode (3);
	printf ("FontEdit, alpha version, started:31-05-97, released:%s !\n", date);
	for (i = 0 ; i < 19 ; i++)
		printf ("%c", nom[i] / 17);
	printf ("\n");
//  printf("\nI am looking for FAST graphics functions (like bars, boxes, lines, ...)");
//  printf("\nin mode 12h (640*480*16 colors).\nSomeone can help me ?\n");
	halt (0);
}

// ==========================================================================

void affiche_carac (unsigned int x, unsigned int y, unsigned char coul,
                    unsigned char num_car)
{
	if (numfonte == 0)
		writexyc_f (numfonte, x, y + 4, coul, num_car);
	else
		if (numfonte == 1)
			writexyc_f (numfonte, x, y + 1, coul, num_car);
		else
			writexyc_f (numfonte, x, y, coul, num_car);
}

void affiche_carac2 (unsigned int x, unsigned int y, unsigned char coul,
                     unsigned char num_car)
// raffiche la trame compltement avant de dessiner le caractre
{
	if (num_car == numcarac)
		bar_trame (x - 5, y - 1, x + 11, y + 16, 12, 0);
	else
		if (select[numfonte][num_car])
			bar_trame (x - 5, y - 1, x + 11, y + 16, 6, 0);
		else 
			bar_trame (x - 5, y - 1, x + 11, y + 16, 1, 0);
	if (numfonte == 0)
		writexyc_f (numfonte, x, y + 4, coul, num_car);
	else
		if (numfonte == 1)
			writexyc_f (numfonte, x, y + 1, coul, num_car);
		else
			writexyc_f (numfonte, x, y, coul, num_car);
}

void dessine_carac (unsigned char caractere[16])
{
	unsigned int	i, j;

	for (i = 0 ; i < 8 ; i++)
		for (j = 0 ; j < hauteur[numfonte] ; j++)
			if ( (caractere[j] & (1 << (7 - i))) == 0)
				bar(240 + i * 20 + 2, 175 + j * 19 + 2,
					240 + i * 20 + 18, 175 + j * 19 + 17, 0);
			else
				bar(240 + i * 20 + 2, 175 + j * 19 + 2,
					240 + i * 20 + 18, 175 + j * 19 + 17, 3);
}

void dessine_carac_mini(unsigned char original[16],unsigned char current[16])
{
	unsigned int	i, j;

	for (i = 0 ; i < 8 ; i++)
		for (j = 0 ; j < 16 ; j++)
			if (j >= hauteur[numfonte])
			{
				bar_trame(i * 8 + 4, 262 + j * 7, i * 8 + 8,
					260 + j * 7 + 5, 7, 0);
				bar_trame(i * 8 + 122, 262 + j * 7, i * 8 + 126,
					260 + j * 7 + 5, 7, 0);
			}
			else
			{
				if ( (original[j] & (1 << (7 - i))) == 0)
					bar(i * 8 + 4, 262 + j * 7, i * 8 + 8,
						260 + j * 7 + 5, 0);
				else
					bar(i * 8 + 4, 262 + j * 7, i * 8 + 8,
						260 + j * 7 + 5, 3);
				if ( (current[j] & (1 << (7 - i))) == 0)
					bar(i * 8 + 122, 262 + j * 7, i * 8 + 126,
						260 + j * 7 + 5, 0);
				else
					bar(i * 8 + 122, 262 + j * 7, i * 8 + 126,
						260 + j * 7 + 5, 3);
			}
}

void dessine_view (unsigned char caractere[16])
{
	unsigned int	i, j;

	for (i = 0 ; i < 8 ; i++)
		for (j = 0 ; j < 16 ; j++)
			if ( (caractere[j] & (1 << (7 - i))) == 0)
				setpix (459 + i, 307 + j, 0);
			else
				setpix (459 + i, 307 + j, 2);
}

// ==========================================================================

extern unsigned char keypressed();
#pragma aux keypressed=\
	"	mov	ax,0100h	"\
	"	int	16h		"\
	"	jnz	un_car		"\
	"	xor	al,al		"\
	"	jmp	fin		"\
	"un_car:			"\
	"	mov	al,1		"\
	"fin:				"\
modify [ah] value [al];

extern unsigned char readkey();
#pragma aux readkey=\
	"xor	ah,ah		"\
	"int	16h		"\
	"mov	scan_code,ah	"\
modify [ah] value [al];

extern unsigned char ctrl_enfonce();
#pragma aux ctrl_enfonce=\
	"mov	ah,2	"\
	"int	16h	"\
	"and	al,4	"\
modify [ah] value [al];

// ==========================================================================

void enter_text (unsigned char nofonte, unsigned int x, unsigned int y,
                 unsigned char coul, unsigned char fond, unsigned char maxi,
                 unsigned char max_lig, char *chaine)
{
	unsigned char	longueur = strlen(chaine), coul_curs = 0, i;
	char		k;

	for (i = 0 ; i < longueur ; i++)
		writexyc (nofonte, x + (i % max_lig) * 8,
			y + ( i / max_lig) * 8, coul, fond, chaine[i]);
	writexyc (nofonte, x + (longueur % max_lig) * 8,
		y + (longueur / max_lig) * 8, coul, fond, '_');
	do
	{
		while (!keypressed())
		{ 
			coul_curs = (coul_curs + 1) % 16;
			waitretrace ();
			writexyc (nofonte, x + (longueur % max_lig) * 8,
				y + (longueur / max_lig) * 8, coul_curs, fond, 254);
		}
		k = readkey ();
		if ( ( ((k >= 'A') && (k <= 'Z')) || ((k >= 'a') && (k <= 'z'))
			|| ((k >= '0') && (k <= '9')) || (k == '_')
			|| (k == '-') || (k == '%') || (k=='=') || (k=='~')
			|| (k=='@') || (k=='!') || (k=='.') || (k==':')
			|| (k=='\\')) && (longueur<maxi))
		{
			writexyc (nofonte, x + (longueur % max_lig) * 8,
				y + (longueur / max_lig) * 8, coul, fond, k);
			chaine[longueur] = k;
			longueur++;
			writexyc (nofonte, x + (longueur % max_lig) * 8,
				y + (longueur / max_lig) * 8, coul, fond, 254);
		}
		else
			if (((k == 8) || (scan_code == 75)) && (longueur > 0))
			{
				writexyc (nofonte, x + (longueur % max_lig) * 8,
					y + (longueur / max_lig) * 8, coul, fond, 32);
				longueur--;
				writexyc (nofonte, x + (longueur % max_lig) * 8,
					y + (longueur / max_lig) * 8, coul, fond, 254);
			}
	}
	while ((k != 27) && (k != 13));
	if (k == 27) longueur = 0;
	if ((k == 13) && (longueur == 0))
		{ chaine[0] = 1; longueur = 1; }
	chaine[longueur] = 0;
}

// ==========================================================================

void load_com()
{
	FILE		*F;
	unsigned int	i;
	char		chaine[42];

	hidemouse ();
	bar3D (414, 414, 554, 479, 5, 7, 8);
	bar3D (427, 443, 431 + 14 * 8 + 2, 473, 5, 7, 8);
	writexy_f (0, 420, 421, 4, "Load COM:");
	writexyc_f (0, 420, 431, 4, '[');
	writexy_f (0, 428, 431, 4, nom_defaut[numfonte]);
	writexyc_f (0, 428 + strlen (nom_defaut[numfonte]) * 8, 431, 4, ']');
	strcpy (chaine, dernier_fichier[numfonte]);
	enter_text (0, 431, 447, 14, 7, 41, 14, chaine);
	bar (414, 414, 554, 479, 0);
	showmouse ();
	if (!chaine[0]) return;
	if (chaine[0]==1) strcpy (chaine, nom_defaut[numfonte]);
	strcpy (dernier_fichier[numfonte], chaine);
	F = fopen (chaine, "rb");
	if (F == NULL)
	{
		hidemouse ();
		bar3D (414, 424, 554, 461, 5, 7, 8);
		writexy_f (0, 424, 434, 4, "File not found!");
		writexy_f (0, 432, 446, 3, "Press any key");
		sound (250); delay (100); nosound ();
		readkey ();
		bar (414, 424, 554, 461, 0);
		showmouse ();
		return;
	}
	if (fseek (F, 21, SEEK_SET) != 0)
	{
		hidemouse ();
		bar3D (414, 424, 554, 461, 5, 7, 8);
		writexy_f (0, 432, 434, 4, "Bad COM file!");
		writexy_f (0, 432, 446, 3, "Press any key");
		sound (250); delay (100); nosound ();
		readkey ();
		bar (414, 424, 554, 461, 0);
		showmouse ();
		fclose (F);
		return;
	}
	switch (numfonte)
	{
		case 0:	for (i = 0 ; i < 256 ; i++)
				fread (nfonte[0][i], hauteur[0], 1, F); break;
		case 1:	for (i = 0 ; i < 256 ; i++)
				fread (nfonte[1][i], hauteur[1], 1, F); break;
		case 2:	fread (nfonte[2], 256 * hauteur[2], 1, F);
	}
	for (i = 0 ; i < 256 ; i++)
		affiche_carac2 ((i % 32) * 18 + 38, 2 + (i / 32) * 19, 2, i);
	for (i = 0 ; i < hauteur[numfonte] ; i++)
		carac[i] = nfonte[numfonte][numcarac][i];
	bar_trame_f ((numcarac % 32) * 18 + 33, (numcarac / 32) * 19 + 1,
		(numcarac % 32) * 18 + 49, (numcarac / 32) * 19 + 18, 12);
	affiche_carac((numcarac%32)*18+38,2+(numcarac/32)*19,15,numcarac);
	dessine_carac(carac);
	dessine_carac_mini(fonte[numfonte][numcarac],
		nfonte[numfonte][numcarac]);
	dessine_view(nfonte[numfonte][numcarac]);
	close(F);
}

void save_com()
{
  unsigned char debut[21]={0xB4,0x05,       // mov ah,05h
                           0xCD,0x10,       // int 10h
                           0xB8,0x10,0x11,  // mov ax,1110h
                           0xBB,0x00,0x10,  // mov bx,1000h
                           0xB9,0x00,0x01,  // mov cx,0100h
                           0x31,0xD2,       // xor dx,dx
                           0xBD,0x15,0x01,  // mov bp,0115h
                           0xCD,0x10,       // int 10h
                           0xC3};           // ret
  FILE *F;
  unsigned int i;
  char chaine[42];

  hidemouse();
  bar3D(414,414,554,479,5,7,8);
  bar3D(427,443,431+14*8+2,473,5,7,8);
  writexy_f(0,420,421,4,"Save COM:");
  writexyc_f(0,420,431,4,'[');
  writexy_f(0,428,431,4,nom_defaut[numfonte]);
  writexyc_f(0,428+strlen(nom_defaut[numfonte])*8,431,4,']');
  strcpy(chaine,dernier_fichier[numfonte]);
  enter_text(0,431,447,14,7,41,14,chaine);
  bar(414,414,554,479,0);
  showmouse();
  if (!chaine[0]) return;
  if (chaine[0]==1) strcpy(chaine,nom_defaut[numfonte]);
  strcpy(dernier_fichier[numfonte],chaine);
  F=fopen(chaine,"wb");
  if (F==NULL)
    {
      hidemouse();
      bar3D(414,424,554,461,5,7,8);
      writexy_f(0,440,434,4,"Write fail!");
      writexy_f(0,432,446,3,"Press any key");
      sound(250); delay(100); nosound();
      readkey();
      bar(414,424,554,461,0);
      showmouse();
    }
  debut[9]=hauteur[numfonte];
  fwrite(debut,sizeof(debut),1,F);
  switch(numfonte)
    {
      case 0:for (i=0;i<256;i++) fwrite(nfonte[0][i],hauteur[0],1,F); break;
      case 1:for (i=0;i<256;i++) fwrite(nfonte[1][i],hauteur[1],1,F); break;
      case 2:fwrite(nfonte[2],256*hauteur[2],1,F);
    }
  fclose(F);
}

// ==========================================================================

void change_fonte()
{
  unsigned int i,j;

  numfonte=(numfonte+1)%3;
  hidemouse();
  memcpy(carac,nfonte[numfonte][numcarac],hauteur[numfonte]);
  dessine_carac(carac);
  dessine_carac_mini(fonte[numfonte][numcarac],
    nfonte[numfonte][numcarac]);
  dessine_view(nfonte[numfonte][numcarac]);
  switch(numfonte)
    {
      case 0:for (i=0;i<8;i++)
               for (j=0;j<8;j++)
                 if ((carac[j] & (1<<(7-i)))==0)
                   bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,0);
                 else
                   bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,3);
             for (i=0;i<8;i++)
               for (j=8;j<16;j++)
                 bar_trame(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,7,0);
             break;
      case 1:for (i=0;i<8;i++)
               for (j=0;j<14;j++)
                 if ((carac[j] & (1<<(7-i)))==0)
                   bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,0);
                 else
                   bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,3);
             for (i=0;i<8;i++)
               for (j=14;j<16;j++)
                 bar_trame(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,7,0);
             break;
      case 2:for (i=0;i<8;i++)
               for (j=0;j<16;j++)
                 if ((carac[j] & (1<<(7-i)))==0)
                   bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,0);
                 else
                   bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,3);
    }
  for (i=0;i<256;i++)
    affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
  bar_trame_f((numcarac%32)*18+33,(numcarac/32)*19+1,(numcarac%32)*18+49,
    (numcarac/32)*19+18,12);
  affiche_carac((numcarac%32)*18+38,2+(numcarac/32)*19,15,numcarac);
  bar_trame(33,156,114,172,1,0);
  if (numfonte==0)
    writexy_f(2,43,157,2,nom_fonte[numfonte]);
  else
    writexy_f(2,39,157,2,nom_fonte[numfonte]);
  showmouse();
}

// ==========================================================================

void affiche_aide()
{
//  rectangle(414,354,519,479,12);
//  lineh(416,520,353,6);
//  linev(520,354,477,6);
  hidemouse();
  bar3D(412,352,521,479,5,7,8);
  writexy_f(0,417,357,14,"Tab");
  writexy_f(0,425,367,15,"Select font");
  writexy_f(0,417,377,14,"Ctrl-Z");
  writexy_f(0,425,387,15,"Reset font");
  writexy_f(0,417,397,14,"Ctrl-S");
  writexy_f(0,425,407,15,"Select all");
  writexy_f(0,417,417,14,"Ctrl-D");
  writexy_f(0,425,427,15,"Deselect all");
  writexy_f(0,417,437,14,"Esc");
  writexy_f(0,425,447,15,"Quit FNTED");
  writexy_f(0,415,464,4,"Press any key");
  showmouse();
  readkey();
  hidemouse();
  bar(412,352,521,479,0);
  showmouse();
}

// ==========================================================================

void RAZ_fonte()
{
  unsigned int i,j;
  char k;

  hidemouse();
  bar3D(414,424,554,479,5,7,8);
  writexy_f(0,425,434,4,"RESET THIS FONT");
  writexy_f(0,429,444,4,"ARE YOU SURE ?");
  writexy_f(0,453,460,15,"Y     N");
  writexy_f(0,461,460,14,"es    o");
  showmouse();
  do k=readkey(); while ((k!=27) && (scan_code!=21) && (scan_code!=49));
  hidemouse();
  bar(414,424,554,479,0);
  if ((k==27) || (scan_code==49))
    { showmouse(); return; }
  for (i=0;i<256;i++)
    for (j=0;j<hauteur[numfonte];j++)
      nfonte[numfonte][i][j]=fonte[numfonte][i][j];
  memcpy(carac,nfonte[numfonte][numcarac],hauteur[numfonte]);
  for (i=0;i<8;i++)
    for (j=0;j<hauteur[numfonte];j++)
      if ((carac[j] & (1<<(7-i)))==0)
        bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,0);
      else
        bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,3);
  for (i=0;i<256;i++)
    affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
  bar_trame_f((numcarac%32)*18+33,(numcarac/32)*19+1,(numcarac%32)*18+49,
    (numcarac/32)*19+18,12);
  affiche_carac((numcarac%32)*18+38,2+(numcarac/32)*19,15,numcarac);
  showmouse();
}

// ==========================================================================

void select_all()
{
  unsigned int i;

  hidemouse();
  for (i=0;i<256;i++)
    {
      select[numfonte][i]=1;
      if (i!=numcarac)
        affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
    }
  showmouse();
}

void deselect_all()
{
  unsigned int i;

  hidemouse();
  for (i=0;i<256;i++)
    {
      select[numfonte][i]=0;
      if (i!=numcarac)
        affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
    }
  showmouse();
}

// ==========================================================================

void init_screen()
{
  int nom[11]={2254,2783,736,1909,1058,1656,1587,1748,1748,1587,1955};
  char chaine[12];
  unsigned int i;
  
  bar_trame_f(33,1,607,151,1);
  for (i=0;i<9;i++) lineh(32,608,i*19,3);
  for (i=0;i<33;i++) linev(i*18+32,0,152,3);
  for (i=0;i<=255;i++) affiche_carac((i%32)*18+38,2+(i/32)*19,2,i);

  for (i=0;i<17;i++)
    {
      lineh(2,66,260+i*7,5);
      lineh(120,184,260+i*7,5);
      lineh(240,400,175+i*19,5);
    }
  for (i=0;i<9;i++)
    {
      linev(i*8+2,260,260+16*7,5);
      linev(i*8+120,260,260+16*7,5);
      linev(240+i*20,175,175+16*19,5);
    }
  rectangle(32,155,115,173,3);
  bar_trame_f(33,156,114,172,1);
  writexy_f(2,39,157,2,nom_fonte[numfonte]);

  writexy_f(0,0,250,14,"Original:");
  writexy_f(0,122,250,14,"Current:");
  writexy_f(0,240,165,14,"New:");

  rectangle(447,300,477,330,5);
  writexy_f(0,445,290,14,"View:");

  bar3D(534,170,639,195,5,7,8);
  writexy_f(0,567,180,1,"Clear");

  bar3D(534,205,639,230,5,7,8);
  writexy_f(0,571,215,1,"Fill");

  bar3D(534,240,639,265,5,7,8);
  writexy_f(0,563,250,1,"Invert");

  bar3D(534,275,639,300,5,7,8);
  writexy_f(0,551,285,1,"Reverse H");

  bar3D(534,310,639,335,5,7,8);
  writexy_f(0,551,320,1,"Reverse V");

  bar3D(534,345,639,370,5,7,8);
  writexy_f(0,536,355,1,"Restore orig.");

  bar3D(534,380,639,405,5,7,8);
  writexy_f(0,536,390,1,"Restore curr.");

//  bar3D(479,424,554,449,5,7,8);
//  writexy_f(0,485,434,4,"Load COM");
  bar3D(564,424,639,449,5,7,8);
  writexy_f(0,570,434,4,"Load COM");
//  bar3D(479,454,554,479,5,7,8);
//  writexy_f(0,485,464,4,"Save COM");
  bar3D(564,454,639,479,5,7,8);
  writexy_f(0,570,464,4,"Save COM");

  bar3D(0,449,105,479,5,7,8);
  writexy_f(2,36,458,14,"QUIT");

  for (i=0;i<11;i++) chaine[i]=nom[i]/23;
  chaine[11]=0;

  writexy_f(2,110,450,8,"FONT EDITOR");
  writexy_f(2,110,465,8,chaine);

  writexy_f(2,0,432,8,"F1=help");

  numcarac=0;
  memset(carac,16,0);
  bar_trame_f((numcarac%32)*18+33,(numcarac/32)*19+1,(numcarac%32)*18+49,
    (numcarac/32)*19+18,12);
  affiche_carac((numcarac%32)*18+38,2+(numcarac/32)*19,15,numcarac);
}

// *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=

void boucle_principale()
{
  unsigned int i,j,k,l;
  char car;

  do
    {
      delay(80);
      do
        {
          infomouse();
          if (keypressed())
            {
              car=readkey();
              if (car==27) retour_dos();
              switch(scan_code)
                {
                  case 15:change_fonte(); break;
                  case 17:if (ctrl_enfonce()) RAZ_fonte(); break;
                  case 31:if (ctrl_enfonce()) select_all(); break;
                  case 32:if (ctrl_enfonce()) deselect_all(); break;
                  case 59:affiche_aide();
                }
            }
        }
      while (bout==0);
      if ((xs>=33) && (xs<=608) && (ys<=151))
        {
          if (bout==1)
            {
              j=(ys/19)*32+(xs-33)/18;
              hidemouse();
              if (memcmp(carac,nfonte[numfonte][numcarac],hauteur[numfonte])!=0)
                {
                  memcpy(nfonte[numfonte][numcarac],carac,hauteur[numfonte]);
                  numcarac^=1;
                  affiche_carac2(((numcarac^1)%32)*18+38,
                    2+((numcarac^1)/32)*19,2,numcarac^1);
                  numcarac^=1;
                }
              else
                {
                  bar_trame_f((numcarac%32)*18+33,(numcarac/32)*19+1,
                    (numcarac%32)*18+49,(numcarac/32)*19+18,
                    1+select[numfonte][numcarac]*5);
                  affiche_carac((numcarac%32)*18+38,2+(numcarac/32)*19,2,
                    numcarac);
                }
              bar_trame_f((j%32)*18+33,(j/32)*19+1,(j%32)*18+49,(j/32)*19+18,12);
              affiche_carac((j%32)*18+38,2+(j/32)*19,15,j);
              numcarac=j;
              memcpy(carac,nfonte[numfonte][numcarac],hauteur[numfonte]);
              dessine_carac(carac);
              dessine_carac_mini(fonte[numfonte][numcarac],
                nfonte[numfonte][numcarac]);
              dessine_view(nfonte[numfonte][numcarac]);
              showmouse();
            }
          else
            {
              j=(ys/19)*32+(xs-33)/18;
              select[numfonte][j]^=1;
              hidemouse();
              affiche_carac2((j%32)*18+38,2+(j/32)*19,2,j);
              showmouse();
              delay(200);
            }
        }
      else
        if ((xs>=240) && (xs<400) && (ys>=175) && (ys<175+hauteur[numfonte]*19))
          {
            i=(xs-240)/20; j=(ys-175)/19;
            if (bout==1)
              {
                if ((carac[j] & (1<<(7-i)))==0)
                  {
                    carac[j]^=1<<(7-i);
                    hidemouse();
                    bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,3);
                    setpix(459+i,307+j,2);
                    showmouse();
                  }
              }
            else
              if ((carac[j] & (1<<(7-i)))!=0)
                {
                  carac[j]^=1<<(7-i);
                  hidemouse();
                  bar(240+i*20+2,175+j*19+2,240+i*20+18,175+j*19+17,0);
                  setpix(459+i,307+j,0);
                  showmouse();
                }
          }
        else
          if ((xs>=534) && (xs<=639))
            {
              if ((ys>=170) && (ys<=195))
                {
                  if (bout==1)
                    {
                      for (i=0;i<hauteur[numfonte];i++) carac[i]=0;
                      hidemouse();
                      dessine_carac(carac);
                      dessine_view(carac);
                      showmouse();
                    }
                  else
                    {
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          for (j=0;j<hauteur[numfonte];j++)
                            nfonte[numfonte][i][j]=0;
                      hidemouse();
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
                      if (select[numfonte][numcarac])
                        {
                          for (i=0;i<hauteur[numfonte];i++) carac[i]=0;
                          dessine_carac(carac);
                          dessine_view(carac);
                        }
                      showmouse();
                      delay(200);
                    }
                }
              else
              if ((ys>=205) && (ys<=230))
                {
                  if (bout==1)
                    {
                      for (i=0;i<hauteur[numfonte];i++) carac[i]=255;
                      hidemouse();
                      dessine_carac(carac);
                      dessine_view(carac);
                      showmouse();
                    }
                  else
                    {
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          for (j=0;j<hauteur[numfonte];j++)
                            nfonte[numfonte][i][j]=255;
                      hidemouse();
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
                      if (select[numfonte][numcarac])
                        {
                          for (i=0;i<hauteur[numfonte];i++) carac[i]=255;
                          dessine_carac(carac);
                          dessine_view(carac);
                        }
                      showmouse();
                      delay(200);
                    }
                }
              else
              if ((ys>=240) && (ys<=265))
                {
                  if (bout==1)
                    {
                      for (j=0;j<hauteur[numfonte];j++)
                        for (i=0;i<8;i++)
                          carac[j]^=1<<(7-i);
                      hidemouse();
                      dessine_carac(carac);
                      dessine_view(carac);
                      showmouse();
                    }
                  else
                    {
                      for (k=0;k<256;k++)
                        if (select[numfonte][k])
                          for (j=0;j<hauteur[numfonte];j++)
                            for (i=0;i<8;i++)
                              nfonte[numfonte][k][j]^=1<<(7-i);
                      hidemouse();
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
                      if (select[numfonte][numcarac])
                        {
                          for (j=0;j<hauteur[numfonte];j++)
                            for (i=0;i<8;i++)
                              carac[j]^=1<<(7-i);
                          dessine_carac(carac);
                          dessine_view(carac);
                        }
                      showmouse();
                      delay(200);
                    }
                }
              else
              if ((ys>=275) && (ys<=300))
                {
                  if (bout==1)
                    {
                      for (j=0;j<hauteur[numfonte];j++)
                        {
                          k=0;
                          for (i=0;i<8;i++)
                            if ((carac[j] & (1<<(7-i)))!=0)
                              k|=1<<i;
                          carac[j]=k;
                        }
                      hidemouse();
                      dessine_carac(carac);
                      dessine_view(carac);
                      showmouse();
                    }
                  else
                    {
                      for (k=0;k<256;k++)
                        if (select[numfonte][k])
                          for (j=0;j<hauteur[numfonte];j++)
                            {
                              l=0;
                              for (i=0;i<8;i++)
                                if ((nfonte[numfonte][k][j] & (1<<(7-i)))!=0)
                                  l|=1<<i;
                              nfonte[numfonte][k][j]=l;
                            }
                      hidemouse();
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
                      if (select[numfonte][numcarac])
                        {
                          for (j=0;j<hauteur[numfonte];j++)
                            {
                              k=0;
                              for (i=0;i<8;i++)
                                if ((carac[j] & (1<<(7-i)))!=0)
                                  k|=1<<i;
                              carac[j]=k;
                            }
                          dessine_carac(carac);
                          dessine_view(carac);
                        }
                      showmouse();
                      delay(200);
                    }
                }
              else
              if ((ys>=310) && (ys<=335))
                {
                  if (bout==1)
                    {
                      for (i=0;i<hauteur[numfonte]/2;i++)
                        {
                          j=carac[i];
                          carac[i]=carac[hauteur[numfonte]-i-1];
                          carac[hauteur[numfonte]-i-1]=j;
                        }
                      hidemouse();
                      dessine_carac(carac);
                      dessine_view(carac);
                      showmouse();
                    }
                  else
                    {
                      for (k=0;k<256;k++)
                        if (select[numfonte][k])
                          for (i=0;i<hauteur[numfonte]/2;i++)
                            {
                              j=nfonte[numfonte][k][i];
                              nfonte[numfonte][k][i]=
                                nfonte[numfonte][k][hauteur[numfonte]-i-1];
                              nfonte[numfonte][k][hauteur[numfonte]-i-1]=j;
                            }
                      hidemouse();
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
                      if (select[numfonte][numcarac])
                        {
                          for (i=0;i<hauteur[numfonte]/2;i++)
                            {
                              j=carac[i];
                              carac[i]=carac[hauteur[numfonte]-i-1];
                              carac[hauteur[numfonte]-i-1]=j;
                            }
                          dessine_carac(carac);
                          dessine_view(carac);
                        }
                      showmouse();
                      delay(200);
                    }
                }
              else
              if ((ys>=345) && (ys<=370))
                {
                  if (bout==1)
                    {
                      for (i=0;i<hauteur[numfonte];i++)
                        carac[i]=fonte[numfonte][numcarac][i];
                      hidemouse();
                      dessine_carac(carac);
                      dessine_view(carac);
                      showmouse();
                    }
                  else
                    {
                      for (k=0;k<256;k++)
                        if (select[numfonte][k])
                          for (i=0;i<hauteur[numfonte];i++)
                            nfonte[numfonte][k][i]=fonte[numfonte][k][i];
                      hidemouse();
                      for (i=0;i<256;i++)
                        if (select[numfonte][i])
                          affiche_carac2((i%32)*18+38,2+(i/32)*19,2,i);
                      if (select[numfonte][numcarac])
                        {
                          for (i=0;i<hauteur[numfonte];i++)
                            carac[i]=fonte[numfonte][numcarac][i];
                          dessine_carac(carac);
                          dessine_view(carac);
                        }
                      showmouse();
                      delay(200);
                    }
                }
              else
              if ((ys>=380) && (ys<=405))
                {
                  for (i=0;i<hauteur[numfonte];i++)
                    carac[i]=nfonte[numfonte][numcarac][i];
                  hidemouse();
                  dessine_carac(carac);
                  dessine_view(carac);
                  showmouse();
                }
              else
              if ((ys>=424) && (ys<=449)) load_com();
              else
              if ((ys>=454) && (ys<=479)) save_com();
            }
          else
            if ((bout==1) && (xs<=105) && (ys>=449)) retour_dos();
    }
  while (1);
}

// **************************************************************************
// **************************************************************************

void main(int argc,char *argv[])
{
  unsigned int i;
  char car;

  if (argc>=2)
    if (strcmp(argv[1],"/?")==0)
      affiche_aide_DOS();
    else
      { printf("\nInvalid option. Type FNTED /? for help.\n"); halt(255); }
/*  if (argc==2)
    {
      if (strcmp(argv[1],"0")==0)
        numfonte=0;
      else
        if (strcmp(argv[1],"1")==0)
          numfonte=1;
        else
          affiche_aide_DOS();
    } */
  if (!is_vga())
    { printf("\nFNTED Error #1: No VGA card...\n\n"); halt(1); }
  init_640_480();
  if (!ismouse())
    { mode(3); printf("\nFNTED Error #2: Mouse not found...\n\n"); halt(2); }
  rgb(1,0,0,20);
  rgb(5,45,45,45);
  rgb(7,30,30,30);
  getfont();
  numfonte=2;
  memcpy(nfonte,fonte,3*256*16);
  for (i=0;i<256;i++)
    { memset(&nfonte[0][i][8],8,0); memset(&nfonte[1][i][14],2,0); }
  for (i=0;i<3;i++) memset(select[i],256,0);
  init_screen();
  dernier_fichier[0][0]=0;
  dernier_fichier[1][0]=0;
  dernier_fichier[2][0]=0;
  showmouse();
  boucle_principale();
}